# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import SetsPG
import PGOpenGLUtils
from OpenGL.GL import *

COLORS = ((1,0,0), (0,0,0), (0,0,1))
OPACITY = 0.3
        
DRAW_FUNCTIONS = (PGOpenGLUtils.draw_sphere, PGOpenGLUtils.draw_cube, PGOpenGLUtils.draw_diamond)


def drawCell(state, coord, value, scale):
    if value>=0:
        color, shape, count, fill = SetsPG.int_to_vector(value)
        # fill of 0 is solid, 1 is translucent, 2 is wireframe
        drawfunc = DRAW_FUNCTIONS[shape]
        wireframe = (fill==2)
        alpha = OPACITY if fill==1 else None
        # count controls size for now rather than actually drawing multiple objects
        if count==1: scale *= 0.66
        elif count==2: scale *= 0.33
        # move forward and compress in z-direction to draw above grid since board is always 2d
        glTranslatef(0, 0, scale*0.5)
        glScalef(1, 1, 0.5)
        drawfunc(color=COLORS[color], scale=scale, wireframe=wireframe, opacity=alpha)
        return True
    return False
    